

/*   well here you go Kelly.  Good luck, hope it helps.  I assumed your
teachers goal here was to introduce the use of pointers to types as used
in funtions.  I hope interface wasn't a big part of the mark...I just didn't have
a lot of time to make it snazzy.  For instance that crappy scanf function
any strings can't contain a space or it goes to hell.  Also with scanf if
the user enters a character instead of a number when scanning into an int variable
things tend to get wacky.  The other thing is that if such strings as those in
the manufacturer feild for instance are too long, they will look terrible in list
view.  Your prof wanted the list to be tabular and well, there are only 80 chars
per line and just 2 of those strings maxxed to their 30 would be too wide for
the margins I've allowed.  In any case other than a few of these little checking
type routines to ensure good screen output, the rest works as it should.

Talk to you soon,
your coder pal Dave    */




//   inventory program for xyz computer parts

#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>


//macro for the maximum number of items that can be held in the database
#define MAXITEMS 10
#define SCREENWIDTH 80  //max characters in 80x25 textmode

enum findmodes {SEARCH,CHECK};  //TWO modes for scanning the data base.  search generates
										  //an error message if the item isn't found and check does not

	//structure to hold individual stock records

	typedef struct tagitem
	{
		int code;			//the id of the item
		char type[30];    //the name of the item
		char mfr[30];		//manufacturer
		char model[30];	//model
		int stockqty;		//how many are in stock
		float price;		//unit retail price
	}item_typ;

//structure embodying the array of item structs

	typedef struct tagDatabase
	{
		item_typ items[MAXITEMS];		//nested structure array of tagitem struct
		int numrecords;					//number of records currently in the database
	}database_typ;



int add_item(database_typ *db);  //adds new items to the database
void setscreen(void);		//clears the screen and redisplays the apptitle
void print_title(void);    //refreshes the apptitle
void remove_item(database_typ *db);  //removes items from the database
int finditem(database_typ *db,int code,int fmode); //checks the data base for an entry defined by int code
																	//reacts a little differently depending on value
																	//of fmode defined by enum types above
void display_item(database_typ *db,int index);  //shows the item on screen
void edit_item(database_typ *db);	//edits the specified item
void list_db(database_typ *db);
void find_item(database_typ *db);

void load_data(database_typ *db);
void save_data(database_typ *db);

char *filename = "database.bdb";		//lol, the extension stands for "boo data base"
//make it global so any function gets it easily and quickly


main()
{
 int done = 0;		//exit flag


//declare the database struct
 database_typ database;
 database.numrecords = 0;		//init the number of records

load_data(&database);

 //begin main prog loop
 while(!done)
 {
	int keypress;     //store the users action
	static int listvisible = 0;
	if(!listvisible)setscreen();

	keypress = getch();		//scan for keypress
	if(listvisible){setscreen();listvisible = 0;}
	keypress = toupper(keypress);		//convert the char to upper case

//key responses
	switch(keypress)
	{
		case 'A':
		{
			add_item(&database);
			break;
		}

		case 'R':
		{
			remove_item(&database);
			break;
		}

		case 'E':
		{
			edit_item(&database);
			break;
		}

		case 'F':
		{
		  find_item(&database);
		  break;
		}

		case 'L':
		{
			list_db(&database);
			listvisible = 1;
//			getch();
			break;
		}


		case 'S':
		{
			save_data(&database);
			break;
		}


		case 'Q':
		{
		  done = 1;
		  break;
		}


	}//end switch

 }//end main prog loop

return(0);
}


int add_item(database_typ *db)
{
	int numrecords = db->numrecords;	//easier access
	float tmp;   //temporary to get price...program crashes while trying to scan input directly
					  // into the structure.  Strange.  So store it here and then pass it to the struct.
	int index = -1; //value is set to corresponding index of array whose member duplicates a new entry
	int code;       //easier access to db->items[].code
	gotoxy(5,3);
	if(numrecords < MAXITEMS)			//make sure the database isn't full
	{
		printf("Enter new item info:\n\n");
		printf("     Enter item code:  ");
		scanf("%d", &db->items[numrecords].code);  //get the code and store it in var
		code = db->items[numrecords].code;
		if((index = finditem(db,code,CHECK)) > -1)  {	//check if the entry allready exists
		printf("\nSorry there is all ready data with this value in the database.  Press a key.");
		getch();
		return(-1);
		}//end if

		printf("\n     Enter type of component, ex...memory, processor, hard drive:  ");
		scanf("%s",db->items[numrecords].type);
		printf("\n     Enter name of manufacturer:  ");
		scanf("%s",db->items[numrecords].mfr);
		printf("\n     Enter model name or description:  ");
		scanf("%s",db->items[numrecords].model);
		printf("\n     Enter number of items in stock:  ");
		scanf("%d", &db->items[numrecords].stockqty);
		printf("\n     Enter price:  ");
		scanf("%f",&tmp);
		db->items[numrecords].price = tmp;

		textcolor(128 + WHITE);  //show a happy flashing message
		db->numrecords++;   //increment number of records
		cprintf("\n\nData Successfully added.   Press a key to continue.");
		getch();   //wait for a key
		textcolor(WHITE); //reset the text color to white
				normvideo();	//take off the bright text
	}//end if

	else {printf("\n\nSorry the database is full, please remove an older record "
					"before entering a new one.\nPress a key to continue.");
					getch();}
}


void setscreen(void)
{
clrscr(); //clear the screen
print_title(); //print the title and help text
}

void print_title(void)
{
	char *appTitle = "Stock Database for XYZ Computer Parts";
	char *helptext = "A = Add, R = Remove, E = Edit, F = Find, L = List, Q = Quit, S = Save";
	int startx;

//	calculate middle of screen and offset to center appTitle
	startx = (SCREENWIDTH/2) - ((strlen(appTitle))/2);
	gotoxy(startx,1);			//go to the calculated x coord
	highvideo();					//highlight the title
	cprintf("%s",appTitle);

	//	calculate middle of screen and offset to center help text
	startx = (SCREENWIDTH/2) - ((strlen(helptext))/2);
	gotoxy(startx,25);
	cprintf("%s",helptext);
	normvideo();					//turn off the highlight
}

void remove_item(database_typ *db)
{  int index = -1;
	int code = 0;
	int confirmStatus;
gotoxy(5,3);
printf("Remove an item from the database");
printf("\n\n     Enter the code for the item you wish to delete:  ");
scanf("%d", &code);

//search for the specified code
if((index = finditem(db,code,SEARCH)) > -1)
{
//make sure the user wants to delete the record
printf("\n\nAre you sure you want to delete this item?  [Y|N]");
confirmStatus = getch();   //wait for the users keypress
confirmStatus = toupper(confirmStatus);	//convert to upper case

//if yes
if(confirmStatus == 'Y')
{
/*if the code requested isn't the last member in the database, then we will
remove the item by moving the last member into the place of the requested one
then decrement the number of records.  If it is the last one, then we need only
decrement numrecords*/

	if(index != db->numrecords-1)
	db->items[index] = db->items[db->numrecords-1];
	if(db->numrecords > 0)db->numrecords--;
}//end if

}//end if confirmStatus


}


int finditem(database_typ *db,int code,int fmode)
{

	//easy access
	int counter,end = db->numrecords-1;
	int numrecords = db->numrecords;


				  //error handling
				  if(db->numrecords == 0 && fmode == SEARCH){
			  printf("\n\nSorry there are no items in the database.  Press a key to continue.");
			  getch();
			  return(-1);}

	/*go ahead and search the specified entry held in the int code argument
	  loop throught all the members in the database*/

	for(counter = 0;counter < numrecords;counter ++)
	{
		if(db->items[counter].code == code)	//if a match is found, display it if
														//fmode is set to SEARCH
		{
		 if(fmode == SEARCH)display_item(db,counter);
		 return(counter);	//tell the calling function at what index the match was
								//found
		}//end if

		//if we loop all the way through with no matches
		else{
			 if(fmode == SEARCH && counter == end)
			{printf("\n\nSorry, no matching entries were found... "
					 "press a key to continue.");
					 getch();
					 return(-1);

							}//end if

			}//end else

	}//end for loop
//default return val
return(-1);
}


void display_item(database_typ *db,int index)
{
	setscreen();
		gotoxy(5,6);
	printf("Record For Item %d",db->items[index].code);
	printf("\n\n1.  Code:               %d",db->items[index].code);
	printf("\n2.  Type:               %s",db->items[index].type);
	printf("\n3.  Manufacturer:       %s",db->items[index].mfr);
	printf("\n4.  Model:              %s",db->items[index].model);
	printf("\n5.  Qty:                %d",db->items[index].stockqty);
	printf("\n6.  Price:              %f",db->items[index].price);

}


void edit_item(database_typ *db)

{  int index = -1;
	int code = 0;
	int done = 0;
	setscreen();
gotoxy(5,3);
printf("Edit Database");
printf("\n\n     Enter the code for the item you wish to edit:  ");
scanf("%d", &code);
beginedit:
//search for the specified code
if((index = finditem(db,code,SEARCH)) > -1)
{
	display_item(db,index);
	gotoxy(1,3);
	printf("Enter the number corresponding to the field you wish to edit, Q to\n"
	"exit edit mode.");
	gotoxy(1,20);
	while(!done)
	{
	switch(getch())
	{
		case '1':
		{
			printf("Sorry, you cannot edit the code for any items.  Press a key to continue.");
			getch();
			gotoxy(1,20);
			printf("             																					");
			gotoxy(1,20);
			break;
		}

		case '2':
		{
			gotoxy(1,20);
			printf("\n     Enter type of component, ex...memory, processor, hard drive:  ");
			scanf("%s",db->items[index].type);
			goto beginedit;
		}


		case '3':
		{
			gotoxy(1,20);
			printf("\n     Enter name of manufacturer:  ");
			scanf("%s", &db->items[index].mfr);
			goto beginedit;
		}

		case '4':
		{
			gotoxy(1,20);
		printf("\n     Enter model name or description:  ");
		scanf("%s", &db->items[index].model);
			goto beginedit;
		}

		case '5':
		{
			gotoxy(1,20);
		printf("\n     Enter number of items in stock:  ");
		scanf("%d", &db->items[index].stockqty);
			goto beginedit;
		}


		case '6':
		{float tmp;
			gotoxy(1,20);
		printf("\n     Enter price:  ");
		scanf("%f",&tmp);
		db->items[index].price = tmp;
			goto beginedit;
		}



		case 'q':
		{
			done = 1;
			break;
		}


			case 'Q':
		{
			done = 1;
			break;
		}
	}//end switch
	}//end while
	}//end if

	}

void list_db(database_typ *db)
{
	int x[6] = {1,10,20,40,50,60};
	int curline = 8;
	int counter;
	char *colnames[] = {"Code","Type","Mfg","Model","Qty","Price"};
	gotoxy(1,3);
	printf("Database List");
	for(counter = 0;counter < 6;counter++)
	{
		gotoxy(x[counter],6);
		printf("%s",colnames[counter]);
	}

	for(counter = 0;counter < db->numrecords;counter ++)
	{
	gotoxy(x[0],curline);
	printf("%d",db->items[counter].code);
	gotoxy(x[1],curline);
	printf("%s",db->items[counter].type);
	gotoxy(x[2],curline);
	printf("%s",db->items[counter].mfr);
	gotoxy(x[3],curline);
	printf("%s",db->items[counter].model);
	gotoxy(x[4],curline);
	printf("%d",db->items[counter].stockqty);
	gotoxy(x[5],curline);
	printf("%f",db->items[counter].price);

	curline++;
	}//end for

}

void find_item(database_typ *db)
{int index = -1;
int code;
gotoxy(1,5);
printf("Enter code for the item you want displayed:  ");
scanf("%d",&code);
if((index = finditem(db,code,SEARCH)) == -1)
printf("\nSorry, no matches were found");
printf("\n\nPress any key to continue");
getch();
}


void load_data(database_typ *db)
{
	FILE *stream;

	if((stream = fopen(filename,"rb")) == NULL)db->numrecords = 0;
	else fread(db,sizeof(database_typ),1,stream);
	fclose(stream);
}


void save_data(database_typ *db)
{
	FILE *stream;
	if((stream = fopen(filename,"w+b")) == NULL)
	{
		puts("Sorry, could not create output file...terminating");
		exit(1);
	}  //pretty grusome but somethings wrong and this is what we're gonna do, exit

	else {			gotoxy(1,20);
			printf("Saving Database to Disk...");
			sleep(1); //make the system look real busy like
			fwrite(db,sizeof(database_typ),1,stream);
			gotoxy(1,20);
			printf("                              ");
			gotoxy(1,20);
			printf("Database saved successfully.");
			sleep(1);
			gotoxy(1,20);
			printf("                              ");
				fclose(stream);
			}//end else
}




